
#ifndef _MPEG_AUDIO_HEADER_
#define _MPEG_AUDIO_HEADER_

#define MPEG_AUDIO_HEADER_SIZE 4

#define MPEG_AUDIO_VERSION_2_5			0
#define MPEG_AUDIO_VERSION_RESERVED		1
#define MPEG_AUDIO_VERSION_2			2
#define MPEG_AUDIO_VERSION_1			3

#define MPEG_AUDIO_LAYER_RESERVED		0
#define MPEG_AUDIO_LAYER_III			1
#define MPEG_AUDIO_LAYER_II				2
#define MPEG_AUDIO_LAYER_I				3


typedef struct mpeg_audio_header
{
	// Byte 0:
	// All 8 bits set to 1

	// Byte 1:
	// Top 3 bits all 1.
	unsigned char MPEGAudioVersion;			// 2 bits
	unsigned char layerDescription;			// 2 bits
	unsigned char protectionBit;				// 1 bit

	// Byte 2:
	unsigned char bitrateIndex;				// 4 bits
	unsigned char samplingRateFrequencyIndex;	// 2 bits
	unsigned char paddingBit;					// 1 bit
	unsigned char privateBit;					// 1 bit

	// Byte 3:
	unsigned char channelMode;					// 2 bits
	unsigned char modeExtension;				// 2 bits
	unsigned char copyright;					// 1 bit
	unsigned char original;					// 1 bit
	unsigned char emphasis;					// 2 bit


	// Bytes 0..3 in all their glory
	unsigned char headerData[MPEG_AUDIO_HEADER_SIZE];
} mpeg_audio_header_t;


int mpeg_audio_header_find ( FILE * f, mpeg_audio_header_t * pHeader );

int mpeg_audio_header_frame_size (mpeg_audio_header_t * pHeader);

int mpeg_audio_header_bitrate(mpeg_audio_header_t * pHeader);

int mpeg_audio_header_sampling_rate(mpeg_audio_header_t * pHeader);

long long mpeg_audio_header_duration(mpeg_audio_header_t * pHeader, long long clock_rate);


#endif 