

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "mpegpesheader.h"


void pes_header_encode_timestamp (unsigned char * data, long long ts, unsigned char prefix)
{
	data[0] = (unsigned char) ((ts>>30) & 0x07);
	data[0] = (prefix << 4) | (data[0] << 1) | 0x01;
	data[1] = (unsigned char) ((ts>>22) & 0xff);
	data[2] = (unsigned char) ((ts>>15) & 0x7f);
	data[2] = (data[2] << 1) | 0x01;
	data[3] = (unsigned char) ((ts>>7) & 0xff);
	data[4] = (unsigned char) (ts & 0x7f);
	data[4] = (data[4] << 1) | 0x01;

}

unsigned long pes_header_write (unsigned char * pBuffer, unsigned long dwPos, PES_header_t * pHeader)
{
	// packet_start_code_prefix
	pBuffer[dwPos++] = 0x00;
	pBuffer[dwPos++] = 0x00;
	pBuffer[dwPos++] = 0x01;

	// stream_type
	pBuffer[dwPos++] = pHeader->stream_type;

	// Write out the PES packet length field.
	pBuffer[dwPos++] = (unsigned char) ((pHeader->PES_packet_length & 0xff00) >> 8);
	pBuffer[dwPos++] = (unsigned char) (pHeader->PES_packet_length & 0x00ff);

	pBuffer[dwPos++] = 
		0x80 |
		(pHeader->PES_scrambling_control << 4) |
		(pHeader->PES_priority << 3) |
		(pHeader->data_alignment_indicator << 2) |
		(pHeader->copyright << 1) |
		(pHeader->original_or_copy)
		;

	//PTS_DTS_flags
	pBuffer[dwPos++] = 0x80;

	// PES_Header_data_length
	pBuffer[dwPos++] = PTS_ENCODED_SIZE_IN_BYTES;

	// We are only required to write a PTS.
	pes_header_encode_timestamp (&pBuffer[dwPos],pHeader->PTS,PTS_ONLY_PREFIX);
	dwPos += PTS_ENCODED_SIZE_IN_BYTES;		

	return dwPos;

}

