

#ifndef _MPEG_PES_HEADER_
#define _MPEG_PES_HEADER_

typedef struct PES_header
{
	unsigned char stream_type;
	unsigned short PES_packet_length;	
	unsigned char PES_scrambling_control;
	unsigned char PES_priority;
	unsigned char data_alignment_indicator;
	unsigned char copyright;
	unsigned char original_or_copy;	
	long long PTS;
	
} PES_header_t;


#define MINIMUM_PES_PACKET_LENGTH				3

#define PTS_ENCODED_SIZE_IN_BYTES				5
#define PTS_ONLY_PREFIX							0x02
#define PTS_BEFORE_DTS_PREFIX					0x03
#define DTS_AFTER_PTS_PREFIX					0x01

void pes_header_encode_timestamp (unsigned char * data, long long ts, unsigned char prefix);

unsigned long pes_header_write (unsigned char * pBuffer, unsigned long dwPos, PES_header_t * pHeader);




#endif